(* Interface for Oracle *)

type t

module Bits : Oracle.BITSTREAM
                                        (* Pass the set of static rules, as 
                                         * read by the parser *)
val make: unit -> t
    
val addAxiom: t -> Input.axiom -> unit
    
    
val assume: t -> name:string -> Logic.pred -> unit
val undo: t -> unit
    
                                        (* Convert a proof of a given atom *)
val convert: t -> Bits.outbits -> Proof.proof -> Logic.pred -> unit
val check: t -> Logic.pred -> Bits.inbits -> unit
    

