
module type BITSTREAM = 
  sig
    type outbits
                                      (*string is for debugging *)
    val  start: string -> unit 

    val  empty:  unit -> outbits      
    val  put: outbits -> nrchoices:int -> thechoice:int -> unit
    val  putString: outbits -> string -> unit
    val  dump: out_channel -> outbits -> unit


    type inbits
    val  in_of_out: outbits -> inbits
    val  get: inbits  -> nrchoices:int -> int

  end

module type ORACLE = 
    sig
      type t

      module Bits : BITSTREAM
                                        (* Pass the set of static rules, as 
                                         * read by the parser *)
      val make: unit -> t

      val addAxiom: t -> Input.axiom -> unit


      val assume: t -> name:string -> Logic.pred -> unit
      val undo: t -> unit

                                        (* Convert a proof of a given atom *)
      val convert: t -> Bits.outbits -> Proof.proof -> Logic.pred -> unit
      val check: t -> Logic.pred -> Bits.inbits -> unit

    end



