// astbuild.cc
// code for astbuild.h

#include "astbuild.h"      // this module


E_unary *e_not(Expression *e)
{
  return new E_unary(UNY_NOT, e);
}


E_binary *e_equal(Expression *e1, Expression *e2)
{
  return new E_binary(e1, BIN_EQUAL, e2);
}

E_binary *e_notEqual(Expression *e1, Expression *e2)
{
  return new E_binary(e1, BIN_NOTEQUAL, e2);
}

E_binary *e_plus(Expression *e1, Expression *e2)
{
  return new E_binary(e1, BIN_PLUS, e2);
}
E_binary *e_minus(Expression *e1, Expression *e2)
{
  return new E_binary(e1, BIN_MINUS, e2);
}
E_binary *e_and(Expression *e1, Expression *e2)
{
  return new E_binary(e1, BIN_AND, e2);
}
E_pre *e_pre(E_variable *e)
{
  return new E_pre(e);
}


E_funCall *apply5(E_variable *f, Expression *e1, Expression *e2, Expression *e3, Expression *e4, Expression *e5)
{
  FakeList<ArgExpression> *args = FakeList<ArgExpression>::makeList(new ArgExpression(e5));
  args = args->prepend(new ArgExpression(e4));
  args = args->prepend(new ArgExpression(e3));
  args = args->prepend(new ArgExpression(e2));
  args = args->prepend(new ArgExpression(e1));
  return new E_funCall(f, args);
}

E_funCall *apply4(E_variable *f, Expression *e1, Expression *e2, Expression *e3, Expression *e4)
{
  FakeList<ArgExpression> *args = FakeList<ArgExpression>::makeList(new ArgExpression(e4));
  args = args->prepend(new ArgExpression(e3));
  args = args->prepend(new ArgExpression(e2));
  args = args->prepend(new ArgExpression(e1));
  return new E_funCall(f, args);
}

E_funCall *apply3(E_variable *f, Expression *e1, Expression *e2, Expression *e3)
{
  FakeList<ArgExpression> *args = FakeList<ArgExpression>::makeList(new ArgExpression(e3));
  args = args->prepend(new ArgExpression(e2));
  args = args->prepend(new ArgExpression(e1));
  return new E_funCall(f, args);
}

E_funCall *apply2(E_variable *f, Expression *e1, Expression *e2)
{
  FakeList<ArgExpression> *args = FakeList<ArgExpression>::makeList(new ArgExpression(e2));
  args = args->prepend(new ArgExpression(e1));
  return new E_funCall(f, args);
}

E_variable *makeEVar(SourceLoc loc, StringRef str)
{
  return new E_variable(new PQ_name(loc, str));
}
