// c2v_cpat_aux.cc
// implementations of methods that are declared in cc.ast (and other
// "base" extensions), for the classes declared in c2v_cpat.ast

#include "cc.ast.gen.h"        // C++ AST
#include "cc_print.h"          // PrintEnv


// -------------------------- PQ_patvar -----------------------
StringRef PQ_patvar::getName() const
{
  return name;
}

string PQ_patvar::toComponentString() const
{
  return name;
}

void PQ_patvar::tcheck_pq(Env &, Scope *, LookupFlags)
{
  xfailure("PQ_patvar::tcheck should not be called");
}

void PQ_patvar::print(PrintEnv &env)
{
  env << name;
}


// -------------------------- E_patvar ------------------------
Type *E_patvar::itcheck_x(Env &, Expression *&)
{
  xfailure("E_patvar::itcheck_x should not be called");
  return NULL;
}

void E_patvar::iprint(PrintEnv &env)
{
  env << name;
}

Expression * owner E_patvar::ivcgen(VCEnv &, int)
{
  xfailure("E_patvar::ivcgen should not be called");
  return NULL;
}

Expression * owner E_patvar::vcgenPred(VCEnv &, int)
{
  xfailure("E_patvar::ivcgenPred should not be called");
  return NULL;
}

string E_patvar::tovc(void) const
{
  xfailure("E_patvar::tovc should not be called");
  return "";
}

VExpr * owner E_patvar::ic2vml(C2VML &)
{
  xfailure("E_patvar::ic2vml should not be called");
  return NULL;
}

Pred * owner E_patvar::c2vmlPred(C2VML &)
{
  xfailure("E_patvar::c2vmlPred should not be called");
  return NULL;
}


// -------------------------- S_patvar ------------------------
void S_patvar::itcheck(Env &)
{
  xfailure("S_patvar::itcheck should not be called");
}

void S_patvar::iprint(PrintEnv &env)
{
  env << name;
}

void S_patvar::icfg(CFGEnv &)
{}

void S_patvar::vcgen(VCEnv &, bool, int, Statement *)
{
  xfailure("S_patvar::vcgen should not be called");
}

void S_patvar::ic2vml(C2VML &)
{
  xfailure("S_patvar::ic2vml should not be called");
}


#if 0   // obviated
// ------------------------- TS_patvar ------------------------
Type *TS_patvar::itcheck(Env &, DeclFlags)
{
  xfailure("TS_patvar::itcheck should not be called");
}

void TS_patvar::print(PrintEnv &env)
{
  env << name;
}
#endif // 0


// EOF: c2v_cpat_aux.cc
