; div.thy     -*- Lisp -*-
; division of integers

; give "<" a name we can pattern-match on
(DEFPRED (LT x y) (< x y))

(BG_PUSH (AND
  
  ; div and * are inverses
  (FORALL (x y)
    (EQ (div (* x y) y) x)
  )

  ; product of positives is positive
  (FORALL (x y)
    (IMPLIES
      (AND
        (> x 0)
        (> y 0)
      )
      (> (* x y) 0)
    ))

  (FORALL (x y)
    (IMPLIES
      (AND
        (>= x 0)
        (> y 0)             ; want nonzero denominator
      )
      (AND
        (>= (mod x y) 0)    ; modulus of nonnegatives is nonnegatve
        (< (mod x y) y)     ; modulus is less-or-eq denominator
        (>= (div x y) 0)    ; quotient of nonnegatives is nonnegative
      )
    )
  )

  ; somewhat more complex interaction between div and mod
  (FORALL (x y z)
    (IMPLIES
      (AND        
        (>= x 0)
        (> y 0)             ; nonzero denominator
        (>= z 0)
        (< x (* y z))       ; if x < y*z
      )
      (< (div x y) z)       ; then x/y < z
    ))

  ; lower bound of div
  (FORALL (x y z)   ;(PATS (LT x (div z y)))
    (IMPLIES
      (AND
        (> y 0)
        (<= (* (+ x 1) y) z)      ; if (x+1)*y <= z
      )
      (LT x (div z y))            ; then x < z/y
    ))


))
