// inherit.c
// example with inheritance


// ------------------- preamble ----------------
#include "selupd.model"  // sel/upd
#include "state.model"   // metaVar

// C functions that are modeled directly
void *malloc(int size);


// ---------------- code to verify -------------
typedef struct Parent {
  int x;
  int y;
} Parent;

typedef struct Child {
  Parent *superclass;       // ghost; indicates my superclass
  int x;
  int y;
  int z;
} Child;


// global invariant
int global_inv() { return vc_expression(all_of {
  objct > 0;

  forall(Parent *p) PATS(tag[p]).
    tag[p]==Parent_tag || tag[p]==Child_tag ==> all_of {
      p->x >= 3;
      p->y > p->x;
    };

  forall(Child *c) PATS(tag[c]).
    tag[c]==Child_tag ==> all_of {
      c->z == c->x + c->y;
    };
});}


void f1()
  changes(tag, objct, objsize, Parent)
{
  Parent *p = (Parent*)malloc(sizeof(Parent));
  p->x = 5;
  p->y = 8;
}


void f2()
  changes(tag, objct, objsize, Parent, Child)
{
  Child *c = (Child*)malloc(sizeof(Child));
  c->x = 9;
  c->y = 12;
  c->z = 21;
}


void f3(Child *c)
  pre(0 < c < objct && tag[c]==Child_tag)
{
  assert(c->x >= 3);
  assert(c->y > c->x);
  assert(c->z == c->x + c->y);
  
  Parent *p;
  p = (Parent*)c;       // downcast

  int zoo = p->x;       // field access where static and dynamic types are different
  assert(zoo >= 3);
}
