// innerarray.c
// testcase from pc_keyb.c with arrays in a function


// --------- verifier preamble ----------
// for now, use asm hack to put the includes in
asm("verifier: include \"ptr.vc\";");
asm("verifier: include \"state.vc\";");

// declarations of model functions
int sel(int mem, int p);
int ptr(int addr, int field);

// need to somehow say this is a constant symbolic value, not a global..
// let's try 'const'
int const dead;
int const live;
//int const state;

// more or less true globals
//int mem;
//int meta;
int tag;
//int objsize;    // map from toplevel addresses to sizes
int objct;


// -------------------- code to verify ------------------
struct kbd_repeat {
	int delay;	/* in msec; <= 0: don't change */
	int rate;	/* in msec; <= 0: don't change */
};

#define DEFAULT_KEYB_REP_DELAY	250
#define DEFAULT_KEYB_REP_RATE	30	/* cps */

static struct kbd_repeat kbdrate={
	DEFAULT_KEYB_REP_DELAY,
	DEFAULT_KEYB_REP_RATE
};


struct r2v{
  int r2v_rate;
  unsigned char r2v_val;
};

struct d2v{
  int d2v_delay;
  unsigned char d2v_val;
};


int global_inv() { return vc_expression(all_of {
  0 < objct;
});}


static unsigned char parse_kbd_rate(struct kbd_repeat *r)
  pre(0 < r < objct && tag[r]==kbd_repeat_tag)
  changes(kbd_repeat_tag)
{
	#if 0
	static struct r2v /*{
                int r2v_rate;                // orig: "rate"
                unsigned char r2v_val;       // orig: "val"
	}*/ kbd_rates[]={	{5,0x14},
	        	{7,0x10},
	        	{10,0x0c},
	        	{15,0x08},
	        	{20,0x04},
	        	{25,0x02},
	        	{30,0x00}
	};
	static struct d2v /*{
                int d2v_delay;               // orig: "delay"
	        unsigned char d2v_val;       // orig: "val"
	}*/ kbd_delays[]={{250,0},
			{500,1},
			{750,2},
			{1000,3}
	};                 
	#endif // 0
	
	struct r2v kbd_rates[7];
	struct d2v kbd_delays[4];

	int rate=0,delay=0;
        if (r != NULL){
		int i,new_rate=30,new_delay=250;
		if (r->rate <= 0)
		        r->rate=kbdrate.rate;
		if (r->delay <= 0)
			r->delay=kbdrate.delay;
		for (i=0; i < sizeof(kbd_rates)/sizeof(struct r2v); i++) {
		        invariant {
		          global_inv;
		          0 <= i < 7;
		        }
			if (kbd_rates[i].r2v_rate == r->rate){
			        new_rate=kbd_rates[i].r2v_rate;
			        rate=kbd_rates[i].r2v_val;
			        break;
			}
		}
		for (i=0; i < sizeof(kbd_delays)/sizeof(struct d2v); i++) {
		        invariant {
		          global_inv;
		          0 <= i < 4;
		        }
			if (kbd_delays[i].d2v_delay == r->delay){
				new_delay=kbd_delays[i].d2v_delay;
				delay=kbd_delays[i].d2v_val;
				break;
			}
		}
		r->rate=new_rate;
		r->delay=new_delay;
	}
	return (delay << 5) | rate;
}
