void *malloc(int size);
void memset(void *ptr, int val, int length);
void kfree(void *freedPtr)
;
typedef int loff_t;
typedef int ssize_t;
typedef int size_t;
typedef int filldir_t;
typedef int kdev_t;
typedef int pid_t;
#define printk printf
void printf(char const *fmt, ...);
#define	KERN_EMERG	"<0>"	/* system is unusable			*/
#define	KERN_ALERT	"<1>"	/* action must be taken immediately	*/
#define	KERN_CRIT	"<2>"	/* critical conditions			*/
#define	KERN_ERR	"<3>"	/* error conditions			*/
#define	KERN_WARNING	"<4>"	/* warning conditions			*/
#define	KERN_NOTICE	"<5>"	/* normal but significant condition	*/
#define	KERN_INFO	"<6>"	/* informational			*/
#define	KERN_DEBUG	"<7>"	/* debug-level messages			*/
typedef struct file_operations {
	loff_t (*llseek) (struct file *, loff_t, int);
	ssize_t (*read) (struct file *, char *, size_t, loff_t *);
	ssize_t (*write) (struct file *, const char *, size_t, loff_t *);
	int (*readdir) (struct file *, void *, filldir_t);
	unsigned int (*poll) (struct file *, struct poll_table_struct *);
	int (*ioctl) (struct inode *, struct file *, unsigned int, unsigned long);
	int (*mmap) (struct file *, struct vm_area_struct *);
	int (*open) (struct inode *, struct file *);
	int (*flush) (struct file *);
	int (*release) (struct inode *, struct file *);
} file_operations;
typedef int ModuleId;
enum FileState { FS_CLOSED, FS_OPEN };
typedef struct file {
	struct file_operations	*f_op;
  	unsigned int 		f_flags;
  	loff_t			f_pos;
  	void			*private_data;
        ModuleId                id;
        FileState               state;
} file;
typedef struct inode {
  	kdev_t			i_rdev;
} inode;
int register_chrdev(unsigned int, const char *, struct file_operations *);
int unregister_chrdev(unsigned int, const char *);
typedef struct task_struct {
  	pid_t pid;
} task_struct;
struct task_struct *current;    // current process
#define	ENOMEM		12	/* Out of memory */
#define	EFAULT		14	/* Bad address */
#define	EBUSY		16	/* Device or resource busy */
#define	ENODEV		19	/* No such device */
#define	EINVAL		22	/* Invalid argument */
#define	EUCLEAN		117	/* Structure needs cleaning */
#define O_ACCMODE	   0003
#define O_RDONLY	     00
#define O_WRONLY	     01
#define O_RDWR		     02
#define O_NONBLOCK	  04000
unsigned long copy_to_user(void *to, const void *from, unsigned long n)
;
unsigned long copy_from_user(void *to, const void *from, unsigned long n)
;
#define __copy_from_user copy_from_user
int access_ok(int type, void *addr, int size);
#define VERIFY_READ 0
#define VERIFY_WRITE 1
#define get_user(var, ptr) (var = *(ptr), 0)
#define __get_user(var, ptr) (var = *(ptr), 0)
#define put_user(var, ptr) (*(ptr) = var, 0)
#define MODULE_PARM(var, flags)
#define MODULE_PARM_DESC(var, desc)
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#define _IOC_NRBITS	8
#define _IOC_TYPEBITS	8
#define _IOC_SIZEBITS	14
#define _IOC_DIRBITS	2
#define _IOC_NRMASK	((1 << _IOC_NRBITS)-1)
#define _IOC_TYPEMASK	((1 << _IOC_TYPEBITS)-1)
#define _IOC_SIZEMASK	((1 << _IOC_SIZEBITS)-1)
#define _IOC_DIRMASK	((1 << _IOC_DIRBITS)-1)
#define _IOC_NRSHIFT	0
#define _IOC_TYPESHIFT	(_IOC_NRSHIFT+_IOC_NRBITS)
#define _IOC_SIZESHIFT	(_IOC_TYPESHIFT+_IOC_TYPEBITS)
#define _IOC_DIRSHIFT	(_IOC_SIZESHIFT+_IOC_SIZEBITS)
#define _IOC_NONE	0U
#define _IOC_WRITE	1U
#define _IOC_READ	2U
#define _IOC(dir,type,nr,size) \
	(((dir)  << _IOC_DIRSHIFT) | \
	 ((type) << _IOC_TYPESHIFT) | \
	 ((nr)   << _IOC_NRSHIFT) | \
	 ((size) << _IOC_SIZESHIFT))
#define _IO(type,nr)		_IOC(_IOC_NONE,(type),(nr),0)
#define _IOR(type,nr,size)	_IOC(_IOC_READ,(type),(nr),sizeof(size))
#define _IOW(type,nr,size)	_IOC(_IOC_WRITE,(type),(nr),sizeof(size))
#define _IOWR(type,nr,size)	_IOC(_IOC_READ|_IOC_WRITE,(type),(nr),sizeof(size))
#define _IOC_DIR(nr)		(((nr) >> _IOC_DIRSHIFT) & _IOC_DIRMASK)
#define _IOC_TYPE(nr)		(((nr) >> _IOC_TYPESHIFT) & _IOC_TYPEMASK)
#define _IOC_NR(nr)		(((nr) >> _IOC_NRSHIFT) & _IOC_NRMASK)
#define _IOC_SIZE(nr)		(((nr) >> _IOC_SIZESHIFT) & _IOC_SIZEMASK)
#define IOC_IN		(_IOC_WRITE << _IOC_DIRSHIFT)
#define IOC_OUT		(_IOC_READ << _IOC_DIRSHIFT)
#define IOC_INOUT	((_IOC_WRITE|_IOC_READ) << _IOC_DIRSHIFT)
#define IOCSIZE_MASK	(_IOC_SIZEMASK << _IOC_SIZESHIFT)
#define IOCSIZE_SHIFT	(_IOC_SIZESHIFT)
#define MINOR(dev) (dev & 0xFF)
#define EXPORT_NO_SYMBOLS()
#define MYKMALLOCPRINTK(size) malloc(size)
#define mykfree(p) kfree(p)
#define mykfreesz(p,sz) kfree(p)
typedef int Err;
typedef int bool;
#define false 0
#define true 1
#ifndef min
  #define min(a,b) ((a)<(b) ? (a) : (b))
#endif
#define printkpid(kernLevel, fmt, args...)                    \
  printk(kernLevel "[%d] " fmt, current->pid , ## args);      \
enum {
  DF_LEAKS = 'L',               // report memory leaks at unload time
  DF_OPEN_RELEASE = 'O',        // calls to open and release
  DF_SYSCALL = 'Y',             // system calls other than open and release
  DF_SIGNAL = 'G',              // signal activity
  DF_SLEEP = 'S',               // sleep/wakeup
  DF_BADIOCTL = 'B',            // print when an unknown ioctl is issued
};
#define ERRCALL(call)  \
  err = call;          \
  if (err < 0) {       \
    return err;        \
  }
  #define debugFlagIsSet(flag) false
  #define dprintk(flag, fmt, args...) ((void)0);
  #define dprintkpid(flag, fmt, args...) ((void)0);
  #define CHECK(condition, codeIfFalse)      \
    if (!(condition)) {                      \
      return codeIfFalse;                    \
    }
#define TYPE(dev)   (MINOR(dev) >> 4)     // high nibble
#define NUM(dev)    (MINOR(dev) & 0xF)    // low nibble
typedef struct Scull_Dev
{
  int quantum;              /* the current quantum size in bytes */
  int qset;                 /* the current quantum set array size, in # of pointers */
  unsigned long totsize;
  unsigned int access_key;  /* used by sculluid and scullpriv (to do what?) */
  unsigned int usage;
  int ioctl_scratch_value;
  bool nonblocking;
  char **data;              // (void * owner * owner)
  struct Scull_Dev *next;   // (owner)
  bool first;
} Scull_Dev;
Err scull_open(struct inode *inode, struct file *filp);
Err scull_release(struct inode *inode, struct file *filp);
loff_t scull_lseek(struct file *filp, loff_t off, int whence);
Err scull_ioctl(struct inode *inode, struct file *filp,
                unsigned int cmd, unsigned long arg);
ssize_t scull_read(struct file *filp, char *buf, size_t count,
                   loff_t *f_pos);
ssize_t scull_write(struct file *filp, const char *buf, size_t count,
                    loff_t *f_pos);
enum ModuleState { MS_UNLOADED, MS_LOADED } module_state = MS_UNLOADED;
Err scull_trim(Scull_Dev *dev)
;
Scull_Dev *scull_follow(Scull_Dev *dev, int n)
;
void check_nonblock_change(struct file *filp, char const *caller);
Err init_pipe_module();
void cleanup_pipe_module();
#define SCULL_IOC_MAGIC 'k'
#define SCULL_MALLOC_STATS _IO(SCULL_IOC_MAGIC, 1)
#define SCULL_STORE_VALUE _IOW(SCULL_IOC_MAGIC, 2, /*sizeof*/ int)
#define SCULL_GET_VALUE _IOR(SCULL_IOC_MAGIC, 3, /*sizeof*/ int)
#define SCULL_STORE_VALUE_UNCHECKED _IO(SCULL_IOC_MAGIC, 4)
#define SCULL_MIN_CODE 1
#define SCULL_MAX_CODE 4
#define SCULL "scull: "
#define SCULL_INFO KERN_INFO SCULL
#define SCULL_WARNING KERN_WARNING SCULL
#define SCULL_ERR KERN_ERR SCULL
struct file_operations scull_fops = {
  scull_lseek,
  scull_read,
  scull_write,
  NULL,          /* scull_readdir */
  NULL,          /* scull_select */
  scull_ioctl,
  NULL,          /* scull_mmap */
  scull_open,
  NULL,          // flush
  scull_release,
};
struct file_operations *scull_fop_array[] = {
  &scull_fops,              // type 0: scull (clipboard)
#if 0     // not yet
  &scull_pipe_fops,         //      1: fifo pipe
  &scull_priv_fops,
  &scull_sngl_fops,
  &scull_user_fops,
  &scull_wusr_fops,
#endif // 0
};
#define SCULL_MAX_TYPE 0
int scull_major = 0;        // default: dynamic assignment
MODULE_PARM(scull_major, "i");
MODULE_PARM_DESC(scull_major, "major device number; 0 for dynamic assignment");
int scull_nr_devs = 4;
MODULE_PARM(scull_nr_devs, "i");
MODULE_PARM_DESC(scull_nr_devs, "number of devices per service; in [1,4]");
int scull_quantum = 4000;
MODULE_PARM(scull_quantum, "i");
MODULE_PARM_DESC(scull_quantum, "size in bytes of a quantum; >0");
int scull_qset = 1000;
MODULE_PARM(scull_qset, "i");
MODULE_PARM_DESC(scull_qset, "number of quanta in a quantum set; >0");
char *debug = "OGL";
MODULE_PARM(debug, "s");
MODULE_PARM_DESC(debug,
  "string of debug flags; default is \"OGL\"");
enum {
  DF_ACCESS = 'a',       // various tests with access_ok
  DF_SCRATCH = 's',      // report scratch value exchanges
  DF_NONBLOCK = 'n',     // print detected changes in O_NONBLOCK
};
Scull_Dev *scull_devices = NULL;   // (owner)
#define SCULL_MODULE_ID 22
#define isToplevelDevice(dev) \
  (scull_devices <= (dev) < scull_devices+scull_nr_devs)
Err scull_open(struct inode *inode, struct file *filp)
{
  int type = TYPE(inode->i_rdev);
  int num = NUM(inode->i_rdev);
  Scull_Dev *dev;     // device information (?)
  if (MINOR(inode->i_rdev) == 255) {
    printk(SCULL_INFO "manually decrementing module count...\n");
    MOD_DEC_USE_COUNT;
    return -EUCLEAN;     // :)
  }
  if (type != 0) {
    if (type < 0 || type > SCULL_MAX_TYPE) {
      printk(SCULL_ERR "Minor device number is invalid: %d\n",
             MINOR(inode->i_rdev));
      return -ENODEV;
    }
    filp->f_op = scull_fop_array[type];
    return filp->f_op->open(inode, filp);
  }
  if (num >= scull_nr_devs) {
    printk(SCULL_ERR "Invalid device number: %d\n", num);
    return -ENODEV;
  }
  dev = &scull_devices[num];
  if (filp->f_flags & O_NONBLOCK) {
    dev->nonblocking = 1;
    dprintkpid(DF_OPEN_RELEASE, SCULL "device opened in nonblocking mode\n");
  }
  else {
    dev->nonblocking = 0;
    dprintkpid(DF_OPEN_RELEASE, SCULL "device opened in blocking mode\n");
  }
  if ((filp->f_flags & O_ACCMODE) == O_WRONLY) {
    scull_trim(dev);
  }
  filp->private_data = dev;
  filp->state = FS_OPEN;
  MOD_INC_USE_COUNT;
  return 0;
}
Err scull_release(struct inode *inode, struct file *filp)
{
  check_nonblock_change(filp, "release");
  dprintkpid(DF_OPEN_RELEASE, SCULL "device closed\n");
  filp->state = FS_CLOSED;
  MOD_DEC_USE_COUNT;
  return 0;
}
Err scull_trim(Scull_Dev *dev)
{
  Scull_Dev *next, *dptr;     // for walking the linked list
  int qset = dev->qset;       // 'dev' is always non-null
  int i;
  if (dev->usage) {
    printkpid(SCULL_WARNING, "Attempt to trim scull data while another process "
              "is accessing it.\n");
    return -EBUSY; /* scull_open ignores this error and goes on */
  }
  for (dptr = dev; dptr; dptr = next) {             /* all the list items */
    if (dptr->data) {
      for (i = 0; i < qset; i++) {                  // for each quantum..
        if (dptr->data[i]) {                        // ..if it's there..
          mykfreesz(dptr->data[i], dev->quantum);   // ..free it
          dptr->data[i] = NULL;                     // restore global inv
        }
      }
      mykfreesz(dptr->data, sizeof(char*) * qset);  // free the quantum set
      dptr->data=NULL;                              // this node now has no quantum set
    }
    next = dptr->next;                              // prepare to advance to next item
    if (next) {
      next->prev = NULL;                            // ghost
    }
    if (dptr != dev) {                              /* all of them but the first */
      mykfreesz(dptr, sizeof(Scull_Dev));           // free a list node
    }
    else {
      dev->next = NULL;
    }
  }
  dev->totsize = 0;                    // total size is now 0
  dev->quantum = scull_quantum;
  dev->qset = scull_qset;
  Scull_Dev *p;
  return 0;
}
ssize_t scull_read(
  struct file *filp,         // open-file structure in calling process' area
  char *buf,                 // user-space pointer to destination buffer
  size_t count,              // max # of bytes to copy to 'buf'
  loff_t *ignore_f_pos)      // redundant pointer to filp->f_pos
{
  Scull_Dev *dev = filp->private_data; /* the first listitem */
  int quantum = dev->quantum;
  int qset = dev->qset;
  int itemsize = quantum * qset; /* how many bytes in the listitem */
  unsigned long f_pos = (unsigned long)(filp->f_pos);
  int item, s_pos, q_pos, rest, resULT;    // name 'result' is reserved by verifier...
  dprintkpid(DF_SYSCALL, SCULL "read, count=%d\n", count);
  check_nonblock_change(filp, "read");
  if (f_pos > dev->totsize) {
    return 0;
  }
  if (f_pos + count > dev->totsize) {
    count = dev->totsize - f_pos;
  }
  item = f_pos / itemsize;      // which list node
  rest = f_pos % itemsize;      // offset into the list node
  s_pos = rest / quantum;       // which quatum in the quantum set
  q_pos = rest % quantum;       // offset into the quantum
  dev = scull_follow(dev, item);
  if (!dev) {                               
    printkpid(KERN_WARNING, "scull_follow failed during a read, which is "
              "not supposed to be possible\n");
    return -ENOMEM;
  }
  if (!dev->data)
    return 0; /* don't fill holes */
  if (!dev->data[s_pos])
    return 0;
  if (count > quantum - q_pos)
    count = quantum - q_pos; /* read only up to the end of this quantum */
  dev->usage++; /* the following call may sleep */
  resULT = copy_to_user(buf,                      // user-space destination
                        dev->data[s_pos]+q_pos,   // kernel-space source
                        count);                   // # of bytes to transfer
  if (resULT > 0) {
    printkpid(SCULL_ERR, "copy_to_user reports %d of %d bytes uncopyable\n",
              resULT, count);
    dev->usage--;        // decrement usage because we're safely out of there
    return -EFAULT;      // but don't advance the file position counter
  }
  dev->usage--;
  filp->f_pos += count;
  return count;
}
ssize_t scull_write(
  struct file *filp,          // open-file in process area
  const char *buf,            // user-space pointer to source data
  size_t count,               // amount of data in 'buf'
  loff_t *ignore_f_pos)       // redundant pointer to filp->f_pos
{
  Scull_Dev *dev = filp->private_data;     // list associated with this instance
  Scull_Dev *dptr;                         // for looking at subsequent list nodes
  int quantum = dev->quantum;
  int qset = dev->qset;
  int itemsize = quantum * qset;           // bytes per list node
  unsigned long f_pos = (unsigned long)(filp->f_pos);
  int item, s_pos, q_pos, rest, resULT;
  dprintkpid(DF_SYSCALL, SCULL "write, count=%d\n", count);
  check_nonblock_change(filp, "write");
  item = f_pos / itemsize;
  rest = f_pos % itemsize;
  s_pos = rest / quantum;
  q_pos = rest % quantum;
  dptr = scull_follow(dev, item);
  if (!dptr) {
    return -ENOMEM;
  }
  if (!dptr->data) {
    dptr->data = (char**)MYKMALLOCPRINTK(qset * sizeof(char *));
    if (!dptr->data) {
      return -ENOMEM;
    }
    char **newBlock = dptr->data;
    tag = vc_expression(tag{newBlock := L1TAG});
    L1parent = vc_expression(L1parent{newBlock := dptr});
    memset(dptr->data, 0, qset * sizeof(char *));
  }
  if (!dptr->data[s_pos]) {
    dptr->data[s_pos] = (char*)MYKMALLOCPRINTK(quantum * sizeof(char));
    if (!dptr->data[s_pos]) {
      return -ENOMEM;
    }
    char *newBlock2 = dptr->data[s_pos];
    tag = vc_expression(tag{newBlock2 := L2TAG});
    L2parent = vc_expression(L2parent{newBlock2 := dptr->data});
    L2index = vc_expression(L2index{newBlock2 := s_pos});
  }
  if (count > quantum - q_pos)
    count = quantum - q_pos; /* write only up to the end of this quantum */
  dev->usage++; /* the following call may sleep */
  resULT = copy_from_user(dptr->data[s_pos]+q_pos,     // kernel-space destination
                          buf,                         // user-space source
                          count);                      // # of bytes to copy
  if (resULT > 0) {
    printkpid(SCULL_ERR, "copy_from_user reports %d of %d bytes uncopyable\n",
              resULT, count);
    dev->usage--;        // decrement usage because we're safely out of there
    return -EFAULT;      // but don't advance the file position counter or size
  }
  dev->usage--;
  if (dev->totsize < f_pos + count)
    dev->totsize = f_pos + count;       // the write made the data area bigger
  filp->f_pos += count;              // advance user's position pointer
  return count;                      // success
}
Scull_Dev *scull_follow(Scull_Dev *dev, int n)
{
  while (n--) {
    if (!dev->next) {
      dev->next = (Scull_Dev*)MYKMALLOCPRINTK(sizeof(Scull_Dev));
      if (!dev->next) {
        return NULL;     // violates postcondition, but considered an infeasible path b/c of my model of malloc..
      }
      memset(dev->next, 0, sizeof(Scull_Dev));
      Scull_Dev *obj = dev->next;
      obj->quantum = scull_quantum;
      obj->qset = scull_qset;
      obj->prev = dev;
      obj->first = false;
    }
    dev = dev->next;
    continue;
  }
  return dev;
}
Err init_module(void)
{
  Err resULT, i;
  Scull_Dev *temp_devices;
  if (scull_nr_devs < 1 || scull_nr_devs > 4) {
    printk(SCULL_ERR "scull_nr_devs must be in range [1,4]; you supplied %d.\n",
           scull_nr_devs);
    return -EINVAL;
  }
  resULT = register_chrdev(scull_major, "scull", &scull_fops);
  if (resULT < 0) {
    printk(SCULL_ERR "can't get major %d\n", scull_major);
    return resULT;
  }
  if (scull_major == 0) {
    scull_major = resULT; /* dynamic */
  }
  printk(SCULL_INFO "initing; MAJ=%d devs=%d qntm=%d qset=%d debug=%s\n",
         scull_major, scull_nr_devs, scull_quantum, scull_qset, debug);
  int old_objct = objct;
  temp_devices = (Scull_Dev*)MYKMALLOCPRINTK(scull_nr_devs * sizeof (Scull_Dev));
  if (!temp_devices) {
    resULT = -ENOMEM;
    goto fail_malloc;
  }
  memset(temp_devices, 0, scull_nr_devs * sizeof (Scull_Dev));
  mem = vc_expression(updbothranges(mem,       // manual model for now
    temp_devices, temp_devices+scull_nr_devs,    // address range
    0, Scull_Dev_size,                           // index range
    0));
  for (i=0; i < scull_nr_devs; i++) {
    temp_devices[i].quantum = scull_quantum;
    temp_devices[i].qset = scull_qset;
    temp_devices[i].first = true;
  }
  scull_devices = temp_devices;
  module_state = MS_LOADED;
  if ( (resULT = init_pipe_module()) < 0 ) {
    goto fail_pipe;
  }
  #ifndef DEBUG
    EXPORT_NO_SYMBOLS();
  #endif
  #ifdef SCULL_USE_PROC /* only when available */
    proc_register_dynamic(&proc_root, &scull_proc_entry);
  #endif
  return 0; /* succeed */
fail_pipe:
  mykfreesz(scull_devices+0, scull_nr_devs * sizeof(Scull_Dev));
  scull_devices = NULL;
  module_state = MS_UNLOADED;
  {
    Scull_Dev *dev;
  }
fail_malloc:
  unregister_chrdev(scull_major, "scull");
  return resULT;
}
void cleanup_module(void)
{
  int i;
  Err resULT;
  resULT = unregister_chrdev(scull_major, "scull");
  if (resULT < 0) {
    printk(SCULL_ERR "unregister_chrdev failed with code %d!\n", resULT);
  }
  #ifdef SCULL_USE_PROC
    proc_unregister(&proc_root, scull_proc_entry.low_ino);
  #endif
  for (i=0; i<scull_nr_devs; i++) {
    if (scull_trim(scull_devices+i) < 0) {
      printk(KERN_CRIT "scull: device being unloaded even though there are "
             "still ongoing operations.. this is bad..\n");
      (scull_devices+i)->next = NULL;
    }
  }
  mykfreesz(scull_devices+0, scull_nr_devs * sizeof (Scull_Dev));
  scull_devices = NULL;
  module_state = MS_UNLOADED;
  cleanup_pipe_module();
  printk(SCULL_INFO "device unloaded.\n");
}





============== annotation ====================
asm("verifier: include \"ptr.vc\";");
asm("verifier: include \"state.vc\";");
asm("verifier: include \"div.vc\";");
asm("verifier: include \"bitwise.vc\";");    // bitand
asm("verifier: include \"reach.vc\";");      // canReach, noCycles
asm("verifier: include \"disjoint.vc\";");   // disjoint
asm("verifier: include \"objct.vc\";");      // reachAllocated
asm("verifier: include \"cycles.vc\";");     // noCycles
int sel(int mem, int p);
int ptr(int addr, int field);
int upd(int mem, int addr, int val);
int updflatrange(int mem, int lo, int hi, int v);
int updbothranges(int mem, int loAddr, int hiAddr, int loIndex, int hiIndex, int v);
int canReach(int mem, int field, int src, int dest);
int canReachWO(int mem, int field, int src, int dest, int avoid);
int noCycles(int mem, int field, int ptr);
int disjoint(int mem, int field, int p, int q);
int ptr_field(int ptr);
int ptr_addr(int ptr);
int metaVar(int whatever);
int const dead;
int const live;
int mem;      // for arrays
int meta;     // for arrays
int tag;
int objsize;
int objct;
  pre(tag[freedPtr] != 0)
  post(tag == pre(tag){freedPtr := 0})
  changes(tag)
  pre(all_of {
    0 <= ptr_field(from) <= ptr_field(from)+n <= objsize[ptr_addr(from)];
  })
  pre(all_of {
    0 <= ptr_field(to) <= ptr_field(to)+n <= objsize[ptr_addr(to)];
  })
  struct Scull_Dev *prev;   // ghost
  pre(all_of {
    module_state==MS_LOADED;
    0 < dev < objct;        tag[dev]==Scull_Dev_tag;
    dev->first == true;
  })
  post(all_of {
    result <= 0;
    result==0 ==> dev->next == NULL;
    forall(Scull_Dev *p).
      tag[p]==Scull_Dev_tag &&
      pre(p->next)==NULL
    ==>
      p->next==NULL;
    forall(file *p). tag[p]==file_tag <==> pre(tag)[p]==file_tag;
  })
  changes(mem, meta, tag, Scull_Dev_prev, Scull_Dev_data, Scull_Dev_next,
          Scull_Dev_totsize,               
          Scull_Dev_quantum, Scull_Dev_qset)
  pre(module_state==MS_LOADED &&
      0 < dev < objct &&
      tag[dev]==Scull_Dev_tag &&
      n >= 0)
  post(all_of {
    0 < result < objct;
    tag[result]==Scull_Dev_tag;
    forall(void *p). 0<p<pre(objct) ==> tag[p] == pre(tag)[p];
    objct >= pre(objct);
  })
  changes(mem, meta, tag, objsize, objct,
          Scull_Dev_tag /*all Scull fields*/)
#define L1TAG 101        // tag on array to which 'data' points
#define L2TAG 102        // tag on arrays pointed to by 'data[i]'
#define ZEROED_SCULL_DEV_TAG 103    // Scull_Dev with all zero fields
int L1parent;           // maps L1 addresses to Scull_Dev addresses
int L2parent;           // maps L2 addresses to L1 addresses
int L2index;            // maps L2 addresses to the index that points to them in the parent L1 array
int Scull_Dev_invariants();
define Scull_Dev_invariants(Scull_Dev *dev, int mem, int tag, int objct, 
                            int scull_devices, int scull_nr_devs) {
  tag[dev]==Scull_Dev_tag;
  dev->quantum == scull_quantum;
  dev->qset == scull_qset;
  dev->data!=NULL ==> all_of {
    0 < dev->data < objct;
    tag[dev->data] == L1TAG;
    L1parent[dev->data] == dev;
  };
  dev->next!=NULL ==> all_of {
    0 < dev->next < objct;
    tag[dev->next] == Scull_Dev_tag;
    dev->next != dev;
    dev->next->prev == dev;
    dev->next->first == false;    // 'first' is my new marker for 'toplevel'
  };
  dev->prev!=NULL ==> all_of {
    0 < dev->prev < objct;
    tag[dev->prev] == Scull_Dev_tag;
    dev->prev != dev;
    dev->prev->next == dev;
  };
  dev->first==true ==> dev->prev==NULL;
}
int firstIsTrue(Scull_Dev *dev);
define firstIsTrue(Scull_Dev *dev) {
  dev->first == true;
}
int global_inv() { return vc_expression(all_of {
  0 < objct;
  tag[NULL] == 0;
  0 < scull_nr_devs;
  0 < scull_quantum;
  0 < scull_qset;
  module_state==MS_UNLOADED || module_state==MS_LOADED;
  module_state==MS_UNLOADED ==> scull_devices==NULL;
  module_state==MS_LOADED ==> all_of {
    0 < scull_devices < scull_devices+scull_nr_devs <= objct;
    forall(int i). 0<=i<scull_nr_devs ==> all_of {
      tag[scull_devices+i]==Scull_Dev_tag;
      (scull_devices+i)->first == true;
    };
  };
  forall(file *filp) PATS(filp->state). tag[filp]==file_tag ==>
    filp->state==FS_CLOSED || filp->state==FS_OPEN;
  forall(file *filp) PATS(filp->private_data). tag[filp]==file_tag ==>
    filp->state==FS_OPEN && filp->id==SCULL_MODULE_ID ==> (
      0 < filp->private_data < objct &&
      tag[filp->private_data] == Scull_Dev_tag &&
      firstIsTrue(filp->private_data)
    );
  forall(Scull_Dev *dev) PATS(dev->quantum). tag[dev]==Scull_Dev_tag ==>
    dev->quantum == scull_quantum;
  forall(Scull_Dev *dev) PATS(dev->qset). tag[dev]==Scull_Dev_tag ==>
    dev->qset == scull_qset;
  forall(Scull_Dev *dev) PATS(dev->data). tag[dev]==Scull_Dev_tag ==>
    dev->data!=NULL ==> all_of {
      0 < dev->data < objct;
      tag[dev->data] == L1TAG;
      L1parent[dev->data] == dev;
    };
  forall(Scull_Dev *dev) PATS(dev->next). tag[dev]==Scull_Dev_tag ==>
    dev->next!=NULL ==> all_of {
      0 < dev->next < objct;
      tag[dev->next] == Scull_Dev_tag;
      dev->next != dev;
      dev->next->prev == dev;
      dev->next->first == false;    // 'first' is my new marker for 'toplevel'
    };
  forall(Scull_Dev *dev) PATS(dev->prev). tag[dev]==Scull_Dev_tag ==>
    dev->prev!=NULL ==> all_of {
      0 < dev->prev < objct;
      tag[dev->prev] == Scull_Dev_tag;
      dev->prev != dev;
      dev->prev->next == dev;
    };
  forall(Scull_Dev *dev) PATS(dev->prev/*?*/). tag[dev]==Scull_Dev_tag ==>
    dev->first==true ==> dev->prev==NULL;
  forall(char **data). tag[data]==L1TAG ==> all_of {
    objsize[data] == scull_qset;       // size is fixed
    forall(int i). 0<=i<scull_qset && mem[data,i]!=0 ==> all_of {
      0 < mem[data,i] < objct;
      tag[mem[data,i]]==L2TAG;
      L2parent[mem[data,i]] == data;
      L2index[mem[data,i]] == i;
    };
  };
  forall(char *p). tag[p]==L2TAG ==>
    objsize[p]==scull_quantum;         // size is fixed
});}
  pre(all_of {
    module_state==MS_LOADED;
    0 < inode < objct;      tag[inode] == inode_tag;
    0 < filp < objct;       tag[filp] == file_tag;
    filp->state==FS_CLOSED;
    filp->id==SCULL_MODULE_ID;
  })
  post(all_of {
    result <= 0;
    result==0 ==> filp->state==FS_OPEN;
    result<0  ==> filp->state==FS_CLOSED;
  })
  changes(mem/*?*/, meta/*?*/, tag, file_state, file_f_op, file_private_data,
          Scull_Dev_tag /*all Scull fields*/)
  pre(all_of {
    module_state==MS_LOADED;
    0 < inode < objct;      tag[inode] == inode_tag;
    0 < filp < objct;       tag[filp] == file_tag;
    filp->state==FS_OPEN;
    filp->id==SCULL_MODULE_ID;
  })
  post(all_of {
    result <= 0;
    filp->state==FS_CLOSED;     // regardless of result
  })
  changes(file_state)
  pre(all_of {
    module_state==MS_LOADED;
    0 < dev < objct;        tag[dev]==Scull_Dev_tag;
    dev->first == true;
  })
  post(all_of {
    result <= 0;
    result==0 ==> dev->next == NULL;
    forall(Scull_Dev *p).
      tag[p]==Scull_Dev_tag &&
      pre(p->next)==NULL
    ==>
      p->next==NULL;
    forall(file *p). tag[p]==file_tag <==> pre(tag)[p]==file_tag;
  })
  changes(mem, meta, tag, Scull_Dev_prev, Scull_Dev_data, Scull_Dev_next,
          Scull_Dev_totsize,               
          Scull_Dev_quantum, Scull_Dev_qset)
    invariant {
      global_inv;
      0 < dev < objct;     tag[dev]==Scull_Dev_tag;
      forall(Scull_Dev *p).
        tag[p]==Scull_Dev_tag &&
        pre(p->next)==NULL
      ==>
        p->next==NULL;
      forall(file *p). tag[p]==file_tag <==> pre(tag)[p]==file_tag;
      qset == scull_qset;
      0 < dptr < objct;    tag[dptr]==Scull_Dev_tag;
      dptr->prev == NULL;     // no Scull_Dev is pointing at dptr
      dptr == dev || (dptr->first == false &&
                      dev->next == NULL);
    }
        invariant {
          global_inv;
          0 < dev < objct;     tag[dev]==Scull_Dev_tag;
          forall(Scull_Dev *p).
            tag[p]==Scull_Dev_tag &&
            pre(p->next)==NULL
          ==>
            p->next==NULL;
          forall(file *p). tag[p]==file_tag <==> pre(tag)[p]==file_tag;
          qset == scull_qset;
          0 < dptr < objct;    tag[dptr]==Scull_Dev_tag;
          dptr->prev == NULL;     // no Scull_Dev is pointing at dptr
          dptr == dev || (dptr->first == false &&
                          dev->next == NULL);
          dptr->data != NULL;
          0 <= i < qset;
        }
  pre(all_of {
    module_state==MS_LOADED;
    0 < filp < objct;       tag[filp] == file_tag;
    filp->state==FS_OPEN;
    filp->id==SCULL_MODULE_ID;
    0 <= count;      // is size_t usually 'unsigned'?
  })
  changes(mem/*no*/, meta/*no*/, tag, objsize, objct, file_f_pos,
          Scull_Dev_tag /*all Scull fields*/)
  assert(0 <= rest < itemsize);
  assert(0 <= s_pos < qset);
  assert(0 <= q_pos < quantum);
  pre(all_of {
    module_state==MS_LOADED;
    0 < filp < objct;       tag[filp] == file_tag;
    filp->state==FS_OPEN;
    filp->id==SCULL_MODULE_ID;
    0 <= count;      // is size_t usually 'unsigned'? 
  })
  changes(mem, meta, tag, objsize, objct, L1parent, L2parent, L2index,
          file_f_pos, Scull_Dev_tag /*all Scull fields*/)
  assert(0 <= rest < itemsize);
  assert(0 <= s_pos < qset);
  assert(0 <= q_pos < quantum);
  assert {
    global_inv;
    0 < dev < objct;
    tag[dev]==Scull_Dev_tag;
    dptr->data!=NULL;
    mem[dptr->data,s_pos]!=NULL;
  }
  pre(module_state==MS_LOADED &&
      0 < dev < objct &&
      tag[dev]==Scull_Dev_tag &&
      n >= 0)
  post(all_of {
    0 < result < objct;
    tag[result]==Scull_Dev_tag;
    forall(void *p). 0<p<pre(objct) ==> tag[p] == pre(tag)[p];
    objct >= pre(objct);
  })
  changes(mem, meta, tag, objsize, objct,
          Scull_Dev_tag /*all Scull fields*/)
    invariant {
      global_inv;
      0 < dev < objct;
      tag[dev]==Scull_Dev_tag;
      forall(void *p). 0<p<pre(objct) ==> tag[p] == pre(tag)[p];
      objct >= pre(objct);
      n >= 0;     // not necessary unless I'm worrying about termination
    }
  pre(module_state==MS_UNLOADED)
  post(all_of {
    result <= 0;
    result==0 ==> module_state==MS_LOADED;
    result<0  ==> module_state==MS_UNLOADED;
  })
  changes(mem, meta, tag, objsize, objct, module_state, scull_devices, scull_major,
          Scull_Dev_tag /*all Scull fields*/)
  tag = vc_expression(updflatrange(tag, temp_devices, temp_devices+scull_nr_devs,
                                   ZEROED_SCULL_DEV_TAG));
    invariant {
      global_inv;
      0 <= i < scull_nr_devs;
      0 < old_objct <= temp_devices < temp_devices+scull_nr_devs <= objct;
      forall(file *filp). tag[filp]==file_tag ==> all_of {
        filp->state==FS_OPEN && filp->id==SCULL_MODULE_ID ==>
          0 < filp->private_data < old_objct;
      };
      forall(int j). 0<=j<i ==> all_of {
        tag[temp_devices+j] == Scull_Dev_tag;
        (temp_devices+j)->prev == NULL;
        (temp_devices+j)->next == NULL;
        (temp_devices+j)->first == true;
      };
      forall(int k). i<=k<scull_nr_devs ==> all_of {
        tag[temp_devices+k] == ZEROED_SCULL_DEV_TAG;
        (temp_devices+k)->next == NULL;
        (temp_devices+k)->prev == NULL;
        (temp_devices+k)->data == NULL;
      };
    }
    tag = vc_expression(tag{temp_devices+i := Scull_Dev_tag});
  invariant {
    module_state==MS_LOADED;
    global_inv;
    old_objct <= scull_devices;
    forall(file *filp). tag[filp]==file_tag ==> all_of {
      filp->state==FS_OPEN && filp->id==SCULL_MODULE_ID ==>
        0 < filp->private_data < old_objct;
    };
    forall(int j). 0<=j<scull_nr_devs ==> all_of {
      (scull_devices+j)->next == NULL;
    };
  }
  pre(all_of {
    module_state==MS_LOADED;
    forall(file *filp). !(
      tag[filp]==file_tag &&
      filp->state==FS_OPEN &&     // no open files of mine
      filp->id==SCULL_MODULE_ID
    );
  })
  post(module_state==MS_UNLOADED)
  changes(mem, meta, tag, objsize, objct, module_state, scull_devices,
          Scull_Dev_tag /*all Scull fields*/)
    invariant {
      global_inv;
      module_state==MS_LOADED;
      forall(file *filp). !(
        tag[filp]==file_tag &&
        filp->state==FS_OPEN &&     // no open files of mine
        filp->id==SCULL_MODULE_ID
      );
      0 <= i < scull_nr_devs;
      forall(int j). 0<=j<i ==> (scull_devices+j)->next == NULL;
    }
      assume(!exists(Scull_Dev *dev). dev->prev == scull_devices+i);
  assume(tag[p]==Scull_Dev_tag);
  assume(f_pos >= 0);    // a type-based fact...
  assume(f_pos >= 0);    // a type-based fact...
    assume(tag[dev]==Scull_Dev_tag);
