// sxlexer.h            see license.txt for copyright and terms of use
// lexer for sexps

#ifndef SXLEXER_H
#define SXLEXER_H

#include "baselexer.h"      // BaseLexer
#include "sxtokens.h"       // SXTokenType


// lexer object
class SXLexer : public BaseLexer {
protected:  // funcs
  // do everything for a single-spelling token
  int tok(SXTokenType t);

  // do everything for a multi-spelling token
  int svalTok(SXTokenType t);

  FLEX_OUTPUT_METHOD_DECLS

public:     // funcs
  // make a lexer to scan the given file
  SXLexer(StringTable &strtable, char const *fname);
  ~SXLexer();

  static void tokenFunc(LexerInterface *lex);

  // LexerInterface funcs
  virtual NextTokenFunc getTokenFunc() const;
  virtual string tokenDesc() const;
  virtual string tokenKindDesc(int kind) const;
};


#endif // SXLEXER_H
