  /* vclang.lex */
  /* tokens for vclang */
  
  /* keywords and operators */
"forall"              return tok(TOK_FORALL);
"exists"              return tok(TOK_EXISTS);
"define"              return tok(TOK_DEFINE);
"check_consistency"   return tok(TOK_CHECK_CONSISTENCY);
"var"                 return tok(TOK_VAR);
"assume"              return tok(TOK_ASSUME);
"prove"               return tok(TOK_PROVE);
"lemma"               return tok(TOK_LEMMA);
"notprove"            return tok(TOK_NOTPROVE);
"block"               return tok(TOK_BLOCK);
"include"             return tok(TOK_INCLUDE);
"defpred"             return tok(TOK_DEFPRED);
"freshen"             return tok(TOK_FRESHEN);
"introduce"           return tok(TOK_INTRODUCE);
"let"                 return tok(TOK_LET);
"in"                  return tok(TOK_IN);

":="                  return tok(TOK_COLONEQ);
"?="                  return tok(TOK_QUESTIONEQ);
"==>"                 return tok(TOK_IMPLIES);
"<==>"                return tok(TOK_EQUIVALENT);

  /* avoid backing up */
"<==" {
  yyless(2);     // put back all but 2
  return tok(TOK_LESSEQ);
}

  /* for the stop keyword, eat everything that comes after it */
  /* (user has to manually close any open braces first ... */
"stop."(.|"\n")*      {
  yyterminate();
}

  /* extend notation for integer literals to allow a leading
   * minus sign, since Simplify understands negative integers */
"-"[1-9][0-9]*{INT_SUFFIX}?   {
  return svalTok(TOK_INT_LITERAL);
}


  /* EOF */
